#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Outfile=TIC TAC TOE.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Change2CUI=y
#AutoIt3Wrapper_Res_LegalCopyright=@Gajjar Tejas
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

;INCLUDE IMPORTANT LIB
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>

Global $Button[9] ;Define 9 Button
Global $CharH ;Human Move Char
Global $CharPC ;Computer Char

;Create GUI ..........................................
#region ### START Koda GUI section ### Form=1.kxf
$Form2 = GUICreate("0X", 307, 398, 480, 163)
GUISetFont(20, 400, 0, "Modern")
$Button[0] = GUICtrlCreateButton("", 3, 0, 100, 100)
GUICtrlSetFont(-1, 60, 400, 0, "Arial Black")
$Button[1] = GUICtrlCreateButton("", 103, 0, 100, 100)
GUICtrlSetFont(-1, 60, 400, 0, "Arial Black")
$Button[2] = GUICtrlCreateButton("", 203, 0, 100, 100)
GUICtrlSetFont(-1, 60, 400, 0, "Arial Black")
$Button[3] = GUICtrlCreateButton("", 4, 100, 100, 100)
GUICtrlSetFont(-1, 60, 400, 0, "Arial Black")
$Button[4] = GUICtrlCreateButton("", 104, 100, 100, 100)
GUICtrlSetFont(-1, 60, 400, 0, "Arial Black")
$Button[5] = GUICtrlCreateButton("", 204, 100, 100, 100)
GUICtrlSetFont(-1, 60, 400, 0, "Arial Black")
$Button[6] = GUICtrlCreateButton("", 3, 200, 100, 100)
GUICtrlSetFont(-1, 60, 400, 0, "Arial Black")
$Button[7] = GUICtrlCreateButton("", 103, 200, 100, 100)
GUICtrlSetFont(-1, 60, 400, 0, "Arial Black")
$Button[8] = GUICtrlCreateButton("", 203, 200, 100, 100)
GUICtrlSetFont(-1, 60, 400, 0, "Arial Black")
$Button10 = GUICtrlCreateButton("", 3, 306, 300, 73)
GUICtrlSetFont(-1, 40, 400, 0, "Arial Black")
GUISetState(@SW_SHOW)
#endregion ### END Koda GUI section ###
;Create GUI End..........................................

ConsoleWrite(@CRLF & "Game is yet in testing Mode debug consol is appear Let know me if any problem." & @CRLF)
ConsoleWrite(@CRLF & "Author Email: gajjartejas26@gmail.com" & @CRLF)
_DisableControlS() ;intially disable all gui control

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg

		Case $GUI_EVENT_CLOSE ;if close button pressed close game
			Exit

		Case $Button10 ;if reset/start button pressed

			ConsoleWrite(@CRLF & "Game Started................." & @CRLF)

			If GUICtrlRead($Button10) = "Toss" Then
				$CharH = _RandomChoosePlayer()
				$CharPC = _Inv($CharH)
				_EnableControlS()
			Else
				_DisableControlS()
			EndIf

			If $CharH = "0" Then _Computer_Move()

		Case $Button[0] ;if button 0 pressed
			GUICtrlSetData($Button[0], $CharH)
			GUICtrlSetState($Button[0], $GUI_DISABLE)
			ConsoleWrite("     -->" & 0 & "-->" & $CharH & @CRLF)
			_TakeTurn()

		Case $Button[1];if button 1 pressed
			GUICtrlSetData($Button[1], $CharH)
			GUICtrlSetState($Button[1], $GUI_DISABLE)
			ConsoleWrite("     -->" & 1 & "-->" & $CharH & @CRLF)
			_TakeTurn()

		Case $Button[2];if button 2 pressed
			GUICtrlSetData($Button[2], $CharH)
			GUICtrlSetState($Button[2], $GUI_DISABLE)
			ConsoleWrite("     -->" & 2 & "-->" & $CharH & @CRLF)
			_TakeTurn()

		Case $Button[3];if button 3 pressed
			GUICtrlSetData($Button[3], $CharH)
			GUICtrlSetState($Button[3], $GUI_DISABLE)
			ConsoleWrite("     -->" & 3 & "-->" & $CharH & @CRLF)
			_TakeTurn()

		Case $Button[4];if button 4 pressed
			GUICtrlSetData($Button[4], $CharH)
			GUICtrlSetState($Button[4], $GUI_DISABLE)
			ConsoleWrite("     -->" & 4 & "-->" & $CharH & @CRLF)
			_TakeTurn()

		Case $Button[5];if button 5 pressed
			GUICtrlSetData($Button[5], $CharH)
			GUICtrlSetState($Button[5], $GUI_DISABLE)
			ConsoleWrite("     -->" & 5 & "-->" & $CharH & @CRLF)
			_TakeTurn()

		Case $Button[6];if button 6 pressed
			GUICtrlSetData($Button[6], $CharH)
			GUICtrlSetState($Button[6], $GUI_DISABLE)
			ConsoleWrite("     -->" & 6 & "-->" & $CharH & @CRLF)
			_TakeTurn()

		Case $Button[7];if button 7 pressed
			GUICtrlSetData($Button[7], $CharH)
			GUICtrlSetState($Button[7], $GUI_DISABLE)
			ConsoleWrite("     -->" & 7 & "-->" & $CharH & @CRLF)
			_TakeTurn()

		Case $Button[8];if button 8 pressed
			GUICtrlSetData($Button[8], $CharH)
			GUICtrlSetState($Button[8], $GUI_DISABLE)
			ConsoleWrite("     -->" & 8 & "-->" & $CharH & @CRLF)
			_TakeTurn()
	EndSwitch
WEnd

Func _DisableControlS();Disable all gui controls (on reset button pressed)
	For $i = 0 To 8
		GUICtrlSetData($Button[$i], $i)
		GUICtrlSetState($Button[$i], $GUI_DISABLE)
	Next
	GUICtrlSetData($Button10, "Toss")
EndFunc   ;==>_DisableControlS

Func _EnableControlS();Enable all gui controls (on reset button pressed)
	For $i = 0 To 8
		GUICtrlSetData($Button[$i], "")
		GUICtrlSetState($Button[$i], $GUI_ENABLE)
	Next
	GUICtrlSetData($Button10, "Reset")
EndFunc   ;==>_EnableControlS

Func _RandomChoosePlayer();Randomly choose wo will play first
	Local $Char
	Switch Random(0, 1, 1)
		Case 0
			$Char = "x" ;means player
			$Char1 = "Your"
		Case Else
			$Char = "0";means computer
			$Char1 = "Computers"
	EndSwitch
	MsgBox(0, "Info", $Char1 & " Turns First!")
	Return $Char
EndFunc   ;==>_RandomChoosePlayer

Func _Computer_Move() ;Function (Mind of Computer)

	Sleep(600) ;Delay Move so it visable to user
	;----------------------------------
	; Check if Computer win by checking OPTIONAL MOVE
	;----------------------------------
	ConsoleWrite(1)
	If _TicWin(0, 1, 2) = 1 Then Return 1
	If _TicWin(1, 2, 0) = 1 Then Return 1
	If _TicWin(2, 0, 1) = 1 Then Return 1

	If _TicWin(3, 4, 5) = 1 Then Return 1
	If _TicWin(4, 5, 3) = 1 Then Return 1
	If _TicWin(5, 3, 4) = 1 Then Return 1

	If _TicWin(6, 7, 8) = 1 Then Return 1
	If _TicWin(7, 8, 6) = 1 Then Return 1
	If _TicWin(8, 6, 7) = 1 Then Return 1

	If _TicWin(0, 3, 6) = 1 Then Return 1
	If _TicWin(3, 6, 0) = 1 Then Return 1
	If _TicWin(6, 0, 3) = 1 Then Return 1

	If _TicWin(1, 4, 7) = 1 Then Return 1
	If _TicWin(4, 7, 1) = 1 Then Return 1
	If _TicWin(7, 1, 4) = 1 Then Return 1

	If _TicWin(2, 5, 8) = 1 Then Return 1
	If _TicWin(5, 8, 2) = 1 Then Return 1
	If _TicWin(8, 2, 5) = 1 Then Return 1

	If _TicWin(0, 4, 8) = 1 Then Return 1
	If _TicWin(4, 8, 0) = 1 Then Return 1
	If _TicWin(8, 0, 4) = 1 Then Return 1

	If _TicWin(2, 4, 6) = 1 Then Return 1
	If _TicWin(4, 6, 2) = 1 Then Return 1
	If _TicWin(6, 2, 4) = 1 Then Return 1

	If _TicWin(0, 1, 2) = 1 Then Return 1
	If _TicWin(1, 2, 0) = 1 Then Return 1
	If _TicWin(2, 0, 1) = 1 Then Return 1

	If _TicWin(3, 4, 5) = 1 Then Return 1
	If _TicWin(4, 5, 3) = 1 Then Return 1
	If _TicWin(5, 3, 4) = 1 Then Return 1

	If _TicWin(6, 7, 8) = 1 Then Return 1
	If _TicWin(7, 8, 6) = 1 Then Return 1
	If _TicWin(8, 6, 7) = 1 Then Return 1

	If _TicWin(0, 3, 6) = 1 Then Return 1
	If _TicWin(3, 6, 0) = 1 Then Return 1
	If _TicWin(6, 0, 3) = 1 Then Return 1

	If _TicWin(1, 4, 7) = 1 Then Return 1
	If _TicWin(4, 7, 1) = 1 Then Return 1
	If _TicWin(7, 1, 4) = 1 Then Return 1

	If _TicWin(2, 5, 8) = 1 Then Return 1
	If _TicWin(5, 8, 2) = 1 Then Return 1
	If _TicWin(8, 2, 5) = 1 Then Return 1

	If _TicWin(0, 4, 8) = 1 Then Return 1
	If _TicWin(4, 8, 0) = 1 Then Return 1
	If _TicWin(8, 0, 4) = 1 Then Return 1

	If _TicWin(2, 4, 6) = 1 Then Return 1
	If _TicWin(4, 6, 2) = 1 Then Return 1
	If _TicWin(6, 2, 4) = 1 Then Return 1

	;----------------------------------
	; Check if You win by checking OPTIONAL MOVE
	;----------------------------------
	ConsoleWrite(2)
	If _Tic(0, 1, 2) = 1 Then Return 1
	If _Tic(1, 2, 0) = 1 Then Return 1
	If _Tic(2, 0, 1) = 1 Then Return 1

	If _Tic(3, 4, 5) = 1 Then Return 1
	If _Tic(4, 5, 3) = 1 Then Return 1
	If _Tic(5, 3, 4) = 1 Then Return 1

	If _Tic(6, 7, 8) = 1 Then Return 1
	If _Tic(7, 8, 6) = 1 Then Return 1
	If _Tic(8, 6, 7) = 1 Then Return 1

	If _Tic(0, 3, 6) = 1 Then Return 1
	If _Tic(3, 6, 0) = 1 Then Return 1
	If _Tic(6, 0, 3) = 1 Then Return 1

	If _Tic(1, 4, 7) = 1 Then Return 1
	If _Tic(4, 7, 1) = 1 Then Return 1
	If _Tic(7, 1, 4) = 1 Then Return 1

	If _Tic(2, 5, 8) = 1 Then Return 1
	If _Tic(5, 8, 2) = 1 Then Return 1
	If _Tic(8, 2, 5) = 1 Then Return 1

	If _Tic(0, 4, 8) = 1 Then Return 1
	If _Tic(4, 8, 0) = 1 Then Return 1
	If _Tic(8, 0, 4) = 1 Then Return 1

	If _Tic(2, 4, 6) = 1 Then Return 1
	If _Tic(4, 6, 2) = 1 Then Return 1
	If _Tic(6, 2, 4) = 1 Then Return 1

	If _Tic(0, 1, 2) = 1 Then Return 1
	If _Tic(1, 2, 0) = 1 Then Return 1
	If _Tic(2, 0, 1) = 1 Then Return 1

	If _Tic(3, 4, 5) = 1 Then Return 1
	If _Tic(4, 5, 3) = 1 Then Return 1
	If _Tic(5, 3, 4) = 1 Then Return 1

	If _Tic(6, 7, 8) = 1 Then Return 1
	If _Tic(7, 8, 6) = 1 Then Return 1
	If _Tic(8, 6, 7) = 1 Then Return 1

	If _Tic(0, 3, 6) = 1 Then Return 1
	If _Tic(3, 6, 0) = 1 Then Return 1
	If _Tic(6, 0, 3) = 1 Then Return 1

	If _Tic(1, 4, 7) = 1 Then Return 1
	If _Tic(4, 7, 1) = 1 Then Return 1
	If _Tic(7, 1, 4) = 1 Then Return 1

	If _Tic(2, 5, 8) = 1 Then Return 1
	If _Tic(5, 8, 2) = 1 Then Return 1
	If _Tic(8, 2, 5) = 1 Then Return 1

	If _Tic(0, 4, 8) = 1 Then Return 1
	If _Tic(4, 8, 0) = 1 Then Return 1
	If _Tic(8, 0, 4) = 1 Then Return 1

	If _Tic(2, 4, 6) = 1 Then Return 1
	If _Tic(4, 6, 2) = 1 Then Return 1
	If _Tic(6, 2, 4) = 1 Then Return 1

	;----------------------------------
	;Other Required Move (Like hourse in chess) OPTIONAL MOVE
	;----------------------------------
	ConsoleWrite(3)
	If _Tic(0, 5, 7) = 1 Then Return 1
	If _Tic(0, 7, 5) = 1 Then Return 1
	If _Tic(1, 6, 5) = 1 Then Return 1
	If _Tic(1, 8, 3) = 1 Then Return 1
	If _Tic(2, 3, 7) = 1 Then Return 1
	If _Tic(2, 7, 3) = 1 Then Return 1
	If _Tic(3, 8, 1) = 1 Then Return 1
	If _Tic(5, 6, 1) = 1 Then Return 1
	;----------------------------------
	;Other Required Move OPTIONAL MOVE
	;----------------------------------
	ConsoleWrite(4)
	For $i = 0 To 8
		If GUICtrlRead($Button[$i]) = $CharH Then
			Return _Move_Intl($i)
			$i = 8
		EndIf
	Next
	;----------------------------------
	 ; If we have to this just random move OPTIONAL MOVE
	 ;----------------------------------
	ConsoleWrite(5)
	$rndm = Random(0, 8, 1)
	While Not _Set_IFEmpty($rndm)
		$rndm = Random(0, 8, 1)
	WEnd

EndFunc   ;==>_Computer_Move

Func _Move_Intl($j)
	Switch $j
		Case 4
			If _Set_IFEmpty(Random(0, 8, 1)) = 1 Then Return 1
		Case Else
			If _Set_IFEmpty(4) = 1 Then Return 1
	EndSwitch
EndFunc   ;==>_Move_Intl

Func _Set_IFEmpty($k)
	If GUICtrlRead($Button[$k]) = "" Then
		GUICtrlSetData($Button[$k], $CharPC)
		GUICtrlSetState($Button[$k], $GUI_DISABLE)
		ConsoleWrite("-->" & $k & "-->" & $CharPC & @CRLF)
		Return 1
	EndIf
EndFunc   ;==>_Set_IFEmpty

Func _Tic($a, $b, $C)
	If (GUICtrlRead($Button[$a]) = $CharH And GUICtrlRead($Button[$b]) = $CharH) Then
		If GUICtrlRead($Button[$C]) = "" Then
			GUICtrlSetData($Button[$C], $CharPC)
			GUICtrlSetState($Button[$C], $GUI_DISABLE)
			ConsoleWrite("-->" & $C & "-->" & $CharPC & @CRLF)
			Return 1
		EndIf
	EndIf
EndFunc   ;==>_Tic

Func _TicWin($a, $b, $C)
	If (GUICtrlRead($Button[$a]) = $CharPC And GUICtrlRead($Button[$b]) = $CharPC) Then
		If GUICtrlRead($Button[$C]) = "" Then
			GUICtrlSetData($Button[$C], $CharPC)
			GUICtrlSetState($Button[$C], $GUI_DISABLE)
			ConsoleWrite("-->" & $C & "-->" & $CharPC & @CRLF)
			Return 1
		EndIf
	EndIf
EndFunc   ;==>_TicWin

Func _Inv($Char)
	If $Char = "x" Then
		Return "0"
	Else
		Return "x"
	EndIf
EndFunc   ;==>_Inv

Func _iGetEmptyTurn()
	$j = 0
	For $i = 0 To 8
		If GUICtrlRead($Button[$i]) <> "" Then $j += 1
	Next
	Return $j
EndFunc   ;==>_iGetEmptyTurn

Func _TakeTurn()
	GUISetState(@SW_DISABLE)
	If _CheckWhoWin() = 1 Then Return 1
	_Computer_Move()
	If _CheckWhoWin() = 1 Then Return 1
	GUISetState(@SW_ENABLE)
EndFunc   ;==>_TakeTurn

Func _CheckWhoWin()
	If _ReadBoard($CharPC) = 1 Then
		MsgBox(0, "Info", "Computer Win!")
		_DisableControlS()
	ElseIf _ReadBoard($CharH) = 1 Then
		MsgBox(0, "Info", "You Win!")
		_DisableControlS()
	ElseIf _iGetEmptyTurn() >= 8 Then
		MsgBox(0, "Info", "Tie? Both Intelligence.")
		_DisableControlS()
	EndIf
EndFunc   ;==>_CheckWhoWin

Func _ReadBoard($Char) ;read whole board and return 1 if any body win else return 0
	If (GUICtrlRead($Button[0]) = $Char And GUICtrlRead($Button[1]) = $Char And GUICtrlRead($Button[2]) = $Char) Or _
			(GUICtrlRead($Button[3]) = $Char And GUICtrlRead($Button[4]) = $Char And GUICtrlRead($Button[5]) = $Char) Or _
			(GUICtrlRead($Button[6]) = $Char And GUICtrlRead($Button[7]) = $Char And GUICtrlRead($Button[8]) = $Char) Or _
			(GUICtrlRead($Button[0]) = $Char And GUICtrlRead($Button[3]) = $Char And GUICtrlRead($Button[6]) = $Char) Or _
			(GUICtrlRead($Button[1]) = $Char And GUICtrlRead($Button[4]) = $Char And GUICtrlRead($Button[7]) = $Char) Or _
			(GUICtrlRead($Button[2]) = $Char And GUICtrlRead($Button[5]) = $Char And GUICtrlRead($Button[8]) = $Char) Or _
			(GUICtrlRead($Button[0]) = $Char And GUICtrlRead($Button[4]) = $Char And GUICtrlRead($Button[8]) = $Char) Or _
			(GUICtrlRead($Button[2]) = $Char And GUICtrlRead($Button[4]) = $Char And GUICtrlRead($Button[6]) = $Char) Then Return 1
EndFunc   ;==>_ReadBoard